function dictAr()
  if service.getEditText()
    require "import"
    import "android.net.Uri"
    import "android.text.Html"
    import "com.androlua.Http"
    import "java.util.Locale"
    import "android.os.Handler"
    import "android.os.Looper"
    import "android.os.Vibrator"

    local luajava = require("luajava")
    local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
    local Intent = luajava.bindClass("android.content.Intent")
    local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
    local activity = this
    local handler = Handler(Looper.getMainLooper())
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)
    local vibrator = activity.getSystemService("vibrator")

    local function startVoiceRecognition(activity)
      local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

      handler.postDelayed(function()
        vibrator.vibrate(50)
      end, 350)

      local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
        onReadyForSpeech = function(params)
        end,
        onResults = function(params)
          local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
          local text = results.get(0)

          handler.postDelayed(function()
            vibrator.vibrate(100)
          end, 350)

          if text and text ~= "" then

            if text:lower() == "الغاء" then
              this.postSpeak(1200,"تم إيقافُ الإملاءِ الصوتي. ")
              service.execute("清空")
              return
             elseif text:lower() == "توقف" then
              recognizer.stopListening()
              recognizer.destroy()
              recognizer = nil
              this.postSpeak(200,"تم إيقافُ الإملاءِ الصوتي. ")

              return


             elseif text:lower() == "تراجع" then
              if service.getEditText()
                this.postSpeak(200, "أَعدِ المحاولة. ")
                local node = service.getEditText()
                local text = service.getText(node)
                local lastLineBreak = text:match(".*()\n")
                if lastLineBreak then
                  text = text:sub(1, lastLineBreak - 0)
                 else
                  text = ""
                end
                service.setText(text)
                task(1500, function()
                  startVoiceRecognition(activity)
                end)
               else
                this.postSpeak(200, "لا يوجد مربع تحرير. ")
              end
              return

             elseif text:lower() == "جديد" then
              this.postSpeak(200,"محوُ النص. ")
              task(1600, function()
                service.execute("清空")
                task(100, function()
                  startVoiceRecognition(activity)
                end)
              end)
              return
             elseif text:lower() == "مراجعه النص" then
              gt= service.getText(node)
              this.postSpeak(200,gt)
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return

             elseif text:lower() == "الاوامر" then
              this.postSpeak(200, "الأوامرُ الرئيسية")
              task(1000, function()
                general()
              end)
              return
             elseif text:lower() == "توقف قليلا" then
              this.postSpeak(200,"إرتح قليلاً، ثم إستأنِفِ الإملاءَ بعدَ سماع النغمة. ")
              handler.postDelayed(function()
                startVoiceRecognition(activity)
              end, 15000)
              return

            end

            service.paste(text .. ". \n")

            this.postSpeak(200, text)

            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                startVoiceRecognition(activity)
               else
                handler.postDelayed(checkSpeakingStatus, 1000)
              end
            end

            handler.postDelayed(checkSpeakingStatus, 1500)

           else
            startVoiceRecognition(activity)
          end

        end,
        onError = function(error)
          this.postSpeak(200,"لم يتم التقاط أي نص.")

        end
      })

      recognizer.setRecognitionListener(recognitionListener)
      recognizer.startListening(intent)
    end

    startVoiceRecognition(activity)
   else
    this.postSpeak(200, "لا يوجد مربع تحرير. ")
  end
end

function transDe()
  if service.getEditText()
    require "import"
    import "android.net.Uri"
    import "android.text.Html"
    import "com.androlua.Http"
    import "java.util.Locale"
    import "android.os.Handler"
    import "android.os.Looper"
    import "android.os.Vibrator"

    local luajava = require("luajava")
    local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
    local Intent = luajava.bindClass("android.content.Intent")
    local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
    local activity = this
    local handler = Handler(Looper.getMainLooper())
    local listening = true

    local vibrator = activity.getSystemService("vibrator")
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

    local function startVoiceRecognition(activity)
      local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

      handler.postDelayed(function()
        vibrator.vibrate(50)
      end, 350)

      local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
        onReadyForSpeech = function(params)
        end,
        onResults = function(params)
          local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
          local text = results.get(0)

          handler.postDelayed(function()
            vibrator.vibrate(100)
          end, 350)

          if text and text ~= "" then

            if text:lower() == "الغاء" then
              this.postSpeak(1200,"تم إيقافُ الإملاءِ الصوتي. ")
              service.execute("清空")
              return
             elseif text:lower() == "توقف" then
              if recognizer then
                recognizer.stopListening()
                recognizer.destroy()
                recognizer = nil
              end
              this.postSpeak(200,"تم إيقافُ الإملاءِ الصوتي. ")

              listening = false
              return

             elseif text:lower() == "الاملاء المستمر" then
              this.postSpeak(200,"الإملاء المستمر. ")
              task(1600, function()
                dictAr()
              end)
              return


             elseif text:lower() == "تراجع" then
              if service.getEditText()
                this.postSpeak(200, "أَعدِ المحاولة. ")
                local node = service.getEditText()
                local text = service.getText(node)
                local lastLineBreak = text:match(".*()\n")
                if lastLineBreak then
                  text = text:sub(1, lastLineBreak - 0)
                 else
                  text = ""
                end
                service.setText(text)
                task(1500, function()
                  startVoiceRecognition(activity)
                end)
               else
                this.postSpeak(200, "لا يوجد مربع تحرير. ")
              end
              return

             elseif text:lower() == "جديد" then
              this.postSpeak(200,"محوُ النص. ")
              task(1600, function()
                service.execute("清空")
                task(100, function()
                  startVoiceRecognition(activity)
                end)
              end)
              return
             elseif text:lower() == "ترجمه النص" then
              service.postClick(200,{{"%翻译"}})
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return
             elseif text:lower() == "مراجعه النص" then
              gt= service.getText(node)
              this.postSpeak(200,gt)
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return

             elseif text:lower() == "الاوامر" then
              this.postSpeak(200, "الأوامرُ الرئيسية")
              task(1000, function()
                general()
              end)
              return
             elseif text:lower() == "توقف قليلا" then
              this.postSpeak(200,"إرتح قليلاً، ثم إستأنِفِ الإملاءَ بعدَ سماع النغمة. ")

              handler.postDelayed(function()
                if listening then
                  startVoiceRecognition(activity)
                end
              end, 15000)
              return
            end

            local language = "deutsch"
            local defaultLanguage = Locale.getDefault().getLanguage()
            local languageCodes = { ["deutsch"] = "de" }

            local languageCode = languageCodes[language]
            if languageCode then
              local wordsToTranslate = text
              local translatedWords = ""

              local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(wordsToTranslate)
              url = url .. "&tl=" .. languageCode

              Http.get(url, function(status, result)
                if status == 200 then
                  translatedWords = result:match('<div class="result%-container">([^<]+)</div>')
                  translatedWords = Html.fromHtml(translatedWords).toString()
                  service.paste(translatedWords .. ". \n")
                  this.speak(translatedWords)

                  local function checkSpeakingStatus()
                    if not service.isSpeaking() then
                      startVoiceRecognition(activity)
                     else
                      handler.postDelayed(checkSpeakingStatus, 1000)
                    end
                  end

                  handler.postDelayed(checkSpeakingStatus, 1500)
                end
              end)
            end
           else
          end
        end,
        onError = function(error)
          this.postSpeak(200,"لم يتم التقاط أي نص.")

          if listening then
          end
        end
      })

      recognizer.setRecognitionListener(recognitionListener)
      recognizer.startListening(intent)
    end

    startVoiceRecognition(activity)
   else
    this.postSpeak(200, "لا يوجد مربع تحرير. ")
  end

end

function transEs()
  if service.getEditText()
    require "import"
    import "android.net.Uri"
    import "android.text.Html"
    import "com.androlua.Http"
    import "java.util.Locale"
    import "android.os.Handler"
    import "android.os.Looper"
    import "android.os.Vibrator"

    local luajava = require("luajava")
    local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
    local Intent = luajava.bindClass("android.content.Intent")
    local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
    local activity = this
    local handler = Handler(Looper.getMainLooper())
    local listening = true

    local vibrator = activity.getSystemService("vibrator")
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

    local function startVoiceRecognition(activity)
      local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

      handler.postDelayed(function()
        vibrator.vibrate(50)
      end, 350)

      local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
        onReadyForSpeech = function(params)
        end,
        onResults = function(params)
          local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
          local text = results.get(0)

          handler.postDelayed(function()
            vibrator.vibrate(100)
          end, 350)

          if text and text ~= "" then

            if text:lower() == "الغاء" then
              this.postSpeak(1200,"تم إيقافُ الإملاءِ الصوتي. ")
              service.execute("清空")
              return
             elseif text:lower() == "توقف" then
              if recognizer then
                recognizer.stopListening()
                recognizer.destroy()
                recognizer = nil
              end
              this.postSpeak(200,"تم إيقافُ الإملاءِ الصوتي. ")

              listening = false
              return

             elseif text:lower() == "الاملاء المستمر" then
              this.postSpeak(200,"الإملاء المستمر. ")
              task(1600, function()
                dictAr()
              end)
              return

             elseif text:lower() == "تراجع" then
              if service.getEditText()
                this.postSpeak(200, "أَعدِ المحاولة. ")
                local node = service.getEditText()
                local text = service.getText(node)
                local lastLineBreak = text:match(".*()\n")
                if lastLineBreak then
                  text = text:sub(1, lastLineBreak - 0)
                 else
                  text = ""
                end
                service.setText(text)
                task(1500, function()
                  startVoiceRecognition(activity)
                end)
               else
                this.postSpeak(200, "لا يوجد مربع تحرير. ")
              end
              return

             elseif text:lower() == "جديد" then
              this.postSpeak(200,"محوُ النص. ")
              task(1600, function()
                service.execute("清空")
                task(100, function()
                  startVoiceRecognition(activity)
                end)
              end)
              return
             elseif text:lower() == "ترجمه النص" then
              service.postClick(200,{{"%翻译"}})
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return
             elseif text:lower() == "مراجعه النص" then
              gt= service.getText(node)
              this.postSpeak(200,gt)
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return

             elseif text:lower() == "الاوامر" then
              this.postSpeak(200, "الأوامرُ الرئيسية")
              task(1000, function()
                general()
              end)
              return
             elseif text:lower() == "توقف قليلا" then
              this.postSpeak(200,"إرتح قليلاً، ثم إستأنِفِ الإملاءَ بعدَ سماع النغمة. ")

              handler.postDelayed(function()
                if listening then
                  startVoiceRecognition(activity)
                end
              end, 15000)
              return

            end

            local language = "español"
            local defaultLanguage = Locale.getDefault().getLanguage()
            local languageCodes = { ["español"] = "es" }

            local languageCode = languageCodes[language]
            if languageCode then
              local wordsToTranslate = text
              local translatedWords = ""

              local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(wordsToTranslate)
              url = url .. "&tl=" .. languageCode

              Http.get(url, function(status, result)
                if status == 200 then
                  translatedWords = result:match('<div class="result%-container">([^<]+)</div>')
                  translatedWords = Html.fromHtml(translatedWords).toString()
                  service.paste(translatedWords .. ". \n")
                  this.speak(translatedWords)

                  local function checkSpeakingStatus()
                    if not service.isSpeaking() then
                      startVoiceRecognition(activity)
                     else
                      handler.postDelayed(checkSpeakingStatus, 1000)
                    end
                  end

                  handler.postDelayed(checkSpeakingStatus, 1500)
                end
              end)
            end
           else
          end
        end,
        onError = function(error)
          this.postSpeak(200,"لم يتم التقاط أي نص.")

          if listening then
          end
        end
      })

      recognizer.setRecognitionListener(recognitionListener)
      recognizer.startListening(intent)
    end

    startVoiceRecognition(activity)
   else
    this.postSpeak(200, "لا يوجد مربع تحرير. ")
  end

end

function transIt()
  if service.getEditText()
    require "import"
    import "android.net.Uri"
    import "android.text.Html"
    import "com.androlua.Http"
    import "java.util.Locale"
    import "android.os.Handler"
    import "android.os.Looper"
    import "android.os.Vibrator"

    local luajava = require("luajava")
    local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
    local Intent = luajava.bindClass("android.content.Intent")
    local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
    local activity = this
    local handler = Handler(Looper.getMainLooper())
    local listening = true

    local vibrator = activity.getSystemService("vibrator")
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

    local function startVoiceRecognition(activity)
      local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

      handler.postDelayed(function()
        vibrator.vibrate(50)
      end, 350)

      local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
        onReadyForSpeech = function(params)
        end,
        onResults = function(params)
          local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
          local text = results.get(0)

          handler.postDelayed(function()
            vibrator.vibrate(100)
          end, 350)

          if text and text ~= "" then

            if text:lower() == "الغاء" then
              this.postSpeak(1200,"تم إيقافُ الإملاءِ الصوتي. ")
              service.execute("清空")
              return
             elseif text:lower() == "توقف" then
              if recognizer then
                recognizer.stopListening()
                recognizer.destroy()
                recognizer = nil
              end
              this.postSpeak(200,"تم إيقافُ الإملاءِ الصوتي. ")

              listening = false
              return

             elseif text:lower() == "الاملاء المستمر" then
              this.postSpeak(200,"الإملاء المستمر. ")
              task(1600, function()
                dictAr()
              end)
              return


             elseif text:lower() == "تراجع" then
              if service.getEditText()
                this.postSpeak(200, "أَعدِ المحاولة. ")
                local node = service.getEditText()
                local text = service.getText(node)
                local lastLineBreak = text:match(".*()\n")
                if lastLineBreak then
                  text = text:sub(1, lastLineBreak - 0)
                 else
                  text = ""
                end
                service.setText(text)
                task(1500, function()
                  startVoiceRecognition(activity)
                end)
               else
                this.postSpeak(200, "لا يوجد مربع تحرير. ")
              end
              return

             elseif text:lower() == "جديد" then
              this.postSpeak(200,"محوُ النص. ")
              task(1600, function()
                service.execute("清空")
                task(100, function()
                  startVoiceRecognition(activity)
                end)
              end)
              return
             elseif text:lower() == "ترجمه النص" then
              service.postClick(200,{{"%翻译"}})
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return
             elseif text:lower() == "مراجعه النص" then
              gt= service.getText(node)
              this.postSpeak(200,gt)
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return

             elseif text:lower() == "الاوامر" then
              this.postSpeak(200, "الأوامرُ الرئيسية")
              task(1000, function()
                general()
              end)
              return
             elseif text:lower() == "توقف قليلا" then
              this.postSpeak(200,"إرتح قليلاً، ثم إستأنِفِ الإملاءَ بعدَ سماع النغمة. ")

              handler.postDelayed(function()
                if listening then
                  startVoiceRecognition(activity)
                end
              end, 15000)
              return
            end

            local language = "italiano"
            local defaultLanguage = Locale.getDefault().getLanguage()
            local languageCodes = { ["italiano"] = "it" }

            local languageCode = languageCodes[language]
            if languageCode then
              local wordsToTranslate = text
              local translatedWords = ""

              local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(wordsToTranslate)
              url = url .. "&tl=" .. languageCode

              Http.get(url, function(status, result)
                if status == 200 then
                  translatedWords = result:match('<div class="result%-container">([^<]+)</div>')
                  translatedWords = Html.fromHtml(translatedWords).toString()
                  service.paste(translatedWords .. ". \n")
                  this.speak(translatedWords)

                  local function checkSpeakingStatus()
                    if not service.isSpeaking() then
                      startVoiceRecognition(activity)
                     else
                      handler.postDelayed(checkSpeakingStatus, 1000)
                    end
                  end

                  handler.postDelayed(checkSpeakingStatus, 1500)
                end
              end)
            end
           else
          end
        end,
        onError = function(error)
          this.postSpeak(200,"لم يتم التقاط أي نص.")

          if listening then
          end
        end
      })

      recognizer.setRecognitionListener(recognitionListener)
      recognizer.startListening(intent)
    end

    startVoiceRecognition(activity)
   else
    this.postSpeak(200, "لا يوجد مربع تحرير. ")
  end

end


function transTr()
  if service.getEditText()
    require "import"
    import "android.net.Uri"
    import "android.text.Html"
    import "com.androlua.Http"
    import "java.util.Locale"
    import "android.os.Handler"
    import "android.os.Looper"
    import "android.os.Vibrator"

    local luajava = require("luajava")
    local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
    local Intent = luajava.bindClass("android.content.Intent")
    local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
    local activity = this
    local handler = Handler(Looper.getMainLooper())
    local listening = true

    local vibrator = activity.getSystemService("vibrator")
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

    local function startVoiceRecognition(activity)
      local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

      handler.postDelayed(function()
        vibrator.vibrate(50)
      end, 350)

      local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
        onReadyForSpeech = function(params)
        end,
        onResults = function(params)
          local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
          local text = results.get(0)

          handler.postDelayed(function()
            vibrator.vibrate(100)
          end, 350)

          if text and text ~= "" then

            if text:lower() == "الغاء" then
              this.postSpeak(1200,"تم إيقافُ الإملاءِ الصوتي. ")
              service.execute("清空")
              return
             elseif text:lower() == "توقف" then
              if recognizer then
                recognizer.stopListening()
                recognizer.destroy()
                recognizer = nil
              end
              this.postSpeak(200,"تم إيقافُ الإملاءِ الصوتي. ")

              listening = false
              return

             elseif text:lower() == "الاملاء المستمر" then
              this.postSpeak(200,"الإملاء المستمر. ")
              task(1600, function()
                dictAr()
              end)
              return


             elseif text:lower() == "تراجع" then
              if service.getEditText()
                this.postSpeak(200, "أَعدِ المحاولة. ")
                local node = service.getEditText()
                local text = service.getText(node)
                local lastLineBreak = text:match(".*()\n")
                if lastLineBreak then
                  text = text:sub(1, lastLineBreak - 0)
                 else
                  text = ""
                end
                service.setText(text)
                task(1500, function()
                  startVoiceRecognition(activity)
                end)
               else
                this.postSpeak(200, "لا يوجد مربع تحرير. ")
              end
              return

             elseif text:lower() == "جديد" then
              this.postSpeak(200,"محوُ النص. ")
              task(1600, function()
                service.execute("清空")
                task(100, function()
                  startVoiceRecognition(activity)
                end)
              end)
              return
             elseif text:lower() == "ترجمه النص" then
              service.postClick(200,{{"%翻译"}})
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return
             elseif text:lower() == "مراجعه النص" then
              gt= service.getText(node)
              this.postSpeak(200,gt)
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return

             elseif text:lower() == "الاوامر" then
              this.postSpeak(200, "الأوامرُ الرئيسية")
              task(1000, function()
                general()
              end)
              return
             elseif text:lower() == "توقف قليلا" then
              this.postSpeak(200,"إرتح قليلاً، ثم إستأنِفِ الإملاءَ بعدَ سماع النغمة. ")

              handler.postDelayed(function()
                if listening then
                  startVoiceRecognition(activity)
                end
              end, 15000)
              return
            end

            local language = "turkish"
            local defaultLanguage = Locale.getDefault().getLanguage()
            local languageCodes = { ["turkish"] = "tr" }

            local languageCode = languageCodes[language]
            if languageCode then
              local wordsToTranslate = text
              local translatedWords = ""

              local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(wordsToTranslate)
              url = url .. "&tl=" .. languageCode

              Http.get(url, function(status, result)
                if status == 200 then
                  translatedWords = result:match('<div class="result%-container">([^<]+)</div>')
                  translatedWords = Html.fromHtml(translatedWords).toString()
                  service.paste(translatedWords .. ". \n")
                  this.speak(translatedWords)

                  local function checkSpeakingStatus()
                    if not service.isSpeaking() then
                      startVoiceRecognition(activity)
                     else
                      handler.postDelayed(checkSpeakingStatus, 1000)
                    end
                  end

                  handler.postDelayed(checkSpeakingStatus, 1500)
                end
              end)
            end
           else
          end
        end,
        onError = function(error)
          this.postSpeak(200,"لم يتم التقاط أي نص.")

          if listening then
          end
        end
      })

      recognizer.setRecognitionListener(recognitionListener)
      recognizer.startListening(intent)
    end

    startVoiceRecognition(activity)
   else
    this.postSpeak(200, "لا يوجد مربع تحرير. ")
  end

end

function transZh()
  if service.getEditText()
    require "import"
    import "android.net.Uri"
    import "android.text.Html"
    import "com.androlua.Http"
    import "java.util.Locale"
    import "android.os.Handler"
    import "android.os.Looper"
    import "android.os.Vibrator"

    local luajava = require("luajava")
    local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
    local Intent = luajava.bindClass("android.content.Intent")
    local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
    local activity = this
    local handler = Handler(Looper.getMainLooper())
    local listening = true

    local vibrator = activity.getSystemService("vibrator")
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

    local function startVoiceRecognition(activity)
      local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

      handler.postDelayed(function()
        vibrator.vibrate(50)
      end, 350)

      local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
        onReadyForSpeech = function(params)
        end,
        onResults = function(params)
          local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
          local text = results.get(0)

          handler.postDelayed(function()
            vibrator.vibrate(100)
          end, 350)

          if text and text ~= "" then

            if text:lower() == "الغاء" then
              this.postSpeak(1200,"تم إيقافُ الإملاءِ الصوتي. ")
              service.execute("清空")
              return
             elseif text:lower() == "توقف" then
              if recognizer then
                recognizer.stopListening()
                recognizer.destroy()
                recognizer = nil
              end
              this.postSpeak(200,"تم إيقافُ الإملاءِ الصوتي. ")

              listening = false
              return

             elseif text:lower() == "الاملاء المستمر" then
              this.postSpeak(200,"الإملاء المستمر. ")
              task(1600, function()
                dictAr()
              end)
              return

             elseif text:lower() == "تراجع" then
              if service.getEditText()
                this.postSpeak(200, "أَعدِ المحاولة. ")
                local node = service.getEditText()
                local text = service.getText(node)
                local lastLineBreak = text:match(".*()\n")
                if lastLineBreak then
                  text = text:sub(1, lastLineBreak - 0)
                 else
                  text = ""
                end
                service.setText(text)
                task(1500, function()
                  startVoiceRecognition(activity)
                end)
               else
                this.postSpeak(200, "لا يوجد مربع تحرير. ")
              end
              return

             elseif text:lower() == "جديد" then
              this.postSpeak(200,"محوُ النص. ")
              task(1600, function()
                service.execute("清空")
                task(100, function()
                  startVoiceRecognition(activity)
                end)
              end)
              return
             elseif text:lower() == "ترجمه النص" then
              service.postClick(200,{{"%翻译"}})
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return
             elseif text:lower() == "مراجعه النص" then
              gt= service.getText(node)
              this.postSpeak(200,gt)
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return

             elseif text:lower() == "الاوامر" then
              this.postSpeak(200, "الأوامرُ الرئيسية")
              task(1000, function()
                general()
              end)
              return
             elseif text:lower() == "توقف قليلا" then
              this.postSpeak(200,"إرتح قليلاً، ثم إستأنِفِ الإملاءَ بعدَ سماع النغمة. ")

              handler.postDelayed(function()
                if listening then
                  startVoiceRecognition(activity)
                end
              end, 15000)
              return

            end

            local language = "chinese"
            local defaultLanguage = Locale.getDefault().getLanguage()
            local languageCodes = { ["chinese"] = "zh-CN" }

            local languageCode = languageCodes[language]
            if languageCode then
              local wordsToTranslate = text
              local translatedWords = ""

              local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(wordsToTranslate)
              url = url .. "&tl=" .. languageCode

              Http.get(url, function(status, result)
                if status == 200 then
                  translatedWords = result:match('<div class="result%-container">([^<]+)</div>')
                  translatedWords = Html.fromHtml(translatedWords).toString()
                  service.paste(translatedWords .. ". \n")
                  this.speak(translatedWords)

                  local function checkSpeakingStatus()
                    if not service.isSpeaking() then
                      startVoiceRecognition(activity)
                     else
                      handler.postDelayed(checkSpeakingStatus, 1000)
                    end
                  end

                  handler.postDelayed(checkSpeakingStatus, 1500)
                end
              end)
            end
           else
          end
        end,
        onError = function(error)
          this.postSpeak(200,"لم يتم التقاط أي نص.")

          if listening then
          end
        end
      })

      recognizer.setRecognitionListener(recognitionListener)
      recognizer.startListening(intent)
    end

    startVoiceRecognition(activity)
   else
    this.postSpeak(200, "لا يوجد مربع تحرير. ")
  end

end

function transFr()
  if service.getEditText()
    require "import"
    import "android.net.Uri"
    import "android.text.Html"
    import "com.androlua.Http"
    import "java.util.Locale"
    import "android.os.Handler"
    import "android.os.Looper"
    import "android.os.Vibrator"

    local luajava = require("luajava")
    local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
    local Intent = luajava.bindClass("android.content.Intent")
    local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
    local activity = this
    local handler = Handler(Looper.getMainLooper())
    local listening = true

    local vibrator = activity.getSystemService("vibrator")
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

    local function startVoiceRecognition(activity)
      local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

      handler.postDelayed(function()
        vibrator.vibrate(50)
      end, 350)

      local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
        onReadyForSpeech = function(params)
        end,
        onResults = function(params)
          local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
          local text = results.get(0)

          handler.postDelayed(function()
            vibrator.vibrate(100)
          end, 350)

          if text and text ~= "" then

            if text:lower() == "الغاء" then
              this.postSpeak(1200,"تم إيقافُ الإملاءِ الصوتي. ")
              service.execute("清空")
              return
             elseif text:lower() == "توقف" then
              if recognizer then
                recognizer.stopListening()
                recognizer.destroy()
                recognizer = nil
              end
              this.postSpeak(200,"تم إيقافُ الإملاءِ الصوتي. ")

              listening = false
              return

             elseif text:lower() == "الاملاء المستمر" then
              this.postSpeak(200,"الإملاء المستمر. ")
              task(1600, function()
                dictAr()
              end)
              return


             elseif text:lower() == "تراجع" then
              if service.getEditText()
                this.postSpeak(200, "أَعدِ المحاولة. ")
                local node = service.getEditText()
                local text = service.getText(node)
                local lastLineBreak = text:match(".*()\n")
                if lastLineBreak then
                  text = text:sub(1, lastLineBreak - 0)
                 else
                  text = ""
                end
                service.setText(text)
                task(1500, function()
                  startVoiceRecognition(activity)
                end)
               else
                this.postSpeak(200, "لا يوجد مربع تحرير. ")
              end
              return

             elseif text:lower() == "جديد" then
              this.postSpeak(200,"محوُ النص. ")
              task(1600, function()
                service.execute("清空")
                task(100, function()
                  startVoiceRecognition(activity)
                end)
              end)
              return
             elseif text:lower() == "ترجمه النص" then
              service.postClick(200,{{"%翻译"}})
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return
             elseif text:lower() == "مراجعه النص" then
              gt= service.getText(node)
              this.postSpeak(200,gt)
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return

             elseif text:lower() == "الاوامر" then
              this.postSpeak(200, "الأوامرُ الرئيسية")
              task(1000, function()
                general()
              end)
              return
             elseif text:lower() == "توقف قليلا" then
              this.postSpeak(200,"إرتح قليلاً، ثم إستأنِفِ الإملاءَ بعدَ سماع النغمة. ")

              handler.postDelayed(function()
                if listening then
                  startVoiceRecognition(activity)
                end
              end, 15000)
              return
            end

            local language = "french"
            local defaultLanguage = Locale.getDefault().getLanguage()
            local languageCodes = { ["french"] = "fr-FR" }

            local languageCode = languageCodes[language]
            if languageCode then
              local wordsToTranslate = text
              local translatedWords = ""

              local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(wordsToTranslate)
              url = url .. "&tl=" .. languageCode

              Http.get(url, function(status, result)
                if status == 200 then
                  translatedWords = result:match('<div class="result%-container">([^<]+)</div>')
                  translatedWords = Html.fromHtml(translatedWords).toString()
                  service.paste(translatedWords .. ". \n")
                  this.speak(translatedWords)

                  local function checkSpeakingStatus()
                    if not service.isSpeaking() then
                      startVoiceRecognition(activity)
                     else
                      handler.postDelayed(checkSpeakingStatus, 1000)
                    end
                  end

                  handler.postDelayed(checkSpeakingStatus, 1500)
                end
              end)
            end
           else
          end
        end,
        onError = function(error)
          this.postSpeak(200,"لم يتم التقاط أي نص.")

          if listening then
          end
        end
      })

      recognizer.setRecognitionListener(recognitionListener)
      recognizer.startListening(intent)
    end

    startVoiceRecognition(activity)
   else
    this.postSpeak(200, "لا يوجد مربع تحرير. ")
  end

end

function transEn()
  if service.getEditText()
    require "import"
    import "android.net.Uri"
    import "android.text.Html"
    import "com.androlua.Http"
    import "java.util.Locale"
    import "android.os.Handler"
    import "android.os.Looper"
    import "android.os.Vibrator"

    local luajava = require("luajava")
    local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
    local Intent = luajava.bindClass("android.content.Intent")
    local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
    local activity = this
    local handler = Handler(Looper.getMainLooper())
    local listening = true

    local vibrator = activity.getSystemService("vibrator")
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

    local function startVoiceRecognition(activity)
      local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

      handler.postDelayed(function()
        vibrator.vibrate(50)
      end, 350)

      local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
        onReadyForSpeech = function(params)
        end,
        onResults = function(params)
          local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
          local text = results.get(0)

          handler.postDelayed(function()
            vibrator.vibrate(100)
          end, 350)

          if text and text ~= "" then

            if text:lower() == "الغاء" then
              this.postSpeak(1200,"تم إيقافُ الإملاءِ الصوتي. ")
              service.execute("清空")
              return
             elseif text:lower() == "توقف" then
              if recognizer then
                recognizer.stopListening()
                recognizer.destroy()
                recognizer = nil
              end
              this.postSpeak(200,"تم إيقافُ الإملاءِ الصوتي. ")

              listening = false
              return

             elseif text:lower() == "الاملاء المستمر" then
              this.postSpeak(200,"الإملاء المستمر. ")
              task(1600, function()
                dictAr()
              end)
              return

             elseif text:lower() == "تراجع" then
              if service.getEditText()
                this.postSpeak(200, "أَعدِ المحاولة. ")
                local node = service.getEditText()
                local text = service.getText(node)
                local lastLineBreak = text:match(".*()\n")
                if lastLineBreak then
                  text = text:sub(1, lastLineBreak - 0)
                 else
                  text = ""
                end
                service.setText(text)
                task(1500, function()
                  startVoiceRecognition(activity)
                end)
               else
                this.postSpeak(200, "لا يوجد مربع تحرير. ")
              end
              return

             elseif text:lower() == "جديد" then
              this.postSpeak(200,"محوُ النص. ")
              task(1600, function()
                service.execute("清空")
                task(100, function()
                  startVoiceRecognition(activity)
                end)
              end)
              return
             elseif text:lower() == "ترجمه النص" then
              service.postClick(200,{{"%翻译"}})
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return
             elseif text:lower() == "مراجعه النص" then
              gt= service.getText(node)
              this.postSpeak(200,gt)
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return

             elseif text:lower() == "الاوامر" then
              this.postSpeak(200, "الأوامرُ الرئيسية")
              task(1000, function()
                general()
              end)
              return
             elseif text:lower() == "توقف قليلا" then
              this.postSpeak(200,"إرتح قليلاً، ثم إستأنِفِ الإملاءَ بعدَ سماع النغمة. ")

              handler.postDelayed(function()
                if listening then
                  startVoiceRecognition(activity)
                end
              end, 15000)
              return
            end

            local language = "english"
            local defaultLanguage = Locale.getDefault().getLanguage()
            local languageCodes = { ["english"] = "en" }

            local languageCode = languageCodes[language]
            if languageCode then
              local wordsToTranslate = text
              local translatedWords = ""

              local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(wordsToTranslate)
              url = url .. "&tl=" .. languageCode

              Http.get(url, function(status, result)
                if status == 200 then
                  translatedWords = result:match('<div class="result%-container">([^<]+)</div>')
                  translatedWords = Html.fromHtml(translatedWords).toString()
                  service.paste(translatedWords .. ". \n")
                  this.speak(translatedWords)

                  local function checkSpeakingStatus()
                    if not service.isSpeaking() then
                      startVoiceRecognition(activity)
                     else
                      handler.postDelayed(checkSpeakingStatus, 1000)
                    end
                  end

                  handler.postDelayed(checkSpeakingStatus, 1500)
                end
              end)
            end
           else
          end
        end,
        onError = function(error)
          this.postSpeak(200,"لم يتم التقاط أي نص.")

          if listening then
          end
        end
      })

      recognizer.setRecognitionListener(recognitionListener)
      recognizer.startListening(intent)
    end

    startVoiceRecognition(activity)
   else
    this.postSpeak(200, "لا يوجد مربع تحرير. ")
  end

end

function general()
  require "import"
  import "android.net.Uri"
  import "android.text.Html"
  import "com.androlua.Http"
  import "java.util.Locale"
  import "android.os.Handler"
  import "android.os.Looper"
  import "android.os.Vibrator"

  local luajava = require("luajava")
  local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
  local Intent = luajava.bindClass("android.content.Intent")
  local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
  local activity = this
  local handler = Handler(Looper.getMainLooper())
  local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)
  local vibrator = activity.getSystemService("vibrator")

  service.getEditText()
  local function startVoiceRecognition(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

    handler.postDelayed(function()
      vibrator.vibrate(50)
    end, 350)

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
      onReadyForSpeech = function(params)
      end,
      onResults = function(params)
        local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
        local text = results.get(0)

        handler.postDelayed(function()
          vibrator.vibrate(100)
        end, 350)

        if text and text ~= "" then

          if text:lower() == "الغاء" then
            this.postSpeak(1200,"تم إيقافُ الإملاءِ الصوتي. ")
            service.execute("清空")
            return
           elseif text:lower() == "توقف" then
            recognizer.stopListening()
            recognizer.destroy()
            recognizer = nil
            this.postSpeak(200,"تم إيقافُ الإملاءِ الصوتي. ")

            return

           elseif text:lower() == "الترجمه الفرنسيه" then
            this.postSpeak(200,"الفرنسية. . ")
            task(1200, function()
              transFr()
            end)
            return
           elseif text:lower() == "الترجمه التركيه" then
            this.postSpeak(200,"التركية. . ")
            task(1200, function()
              transTr()
            end)
            return
           elseif text:lower() == "الترجمه الصينيه" then
            this.postSpeak(200,"الصينية. . ")
            task(1200, function()
              transZh()
            end)
            return
           elseif text:lower() == "الترجمه الانجليزيه" then
            this.postSpeak(200,"الإنجليزية. . ")
            task(1200, function()
              transEn()
            end)
            return
           elseif text:lower() == "الترجمه الالمانيه" then
            this.postSpeak(200,"الألمانية. . . ")
            task(1200, function()
              transDe()
            end)
            return
           elseif text:lower() == "الترجمه الاسبانيه" then
            this.postSpeak(200,"الإسبانية. ")
            task(1200, function()
              transEs()
            end)
            return
           elseif text:lower() == "الترجمه الايطاليه" then
            this.postSpeak(200,"الإيطالية. ")
            task(1200, function()
              transIt()
            end)
            return
           elseif text:lower() == "الاملاء المستمر" then
            this.postSpeak(200,"الإملاء المستمر. ")
            task(1600, function()
              dictAr()
            end)
            return

           elseif text:lower() == "تراجع" then
            if service.getEditText()
              this.postSpeak(200, "أَعدِ المحاولة. ")
              local node = service.getEditText()
              local text = service.getText(node)
              local lastLineBreak = text:match(".*()\n")
              if lastLineBreak then
                text = text:sub(1, lastLineBreak - 0)
               else
                text = ""
              end
              service.setText(text)
              task(1500, function()
                startVoiceRecognition(activity)
              end)
             else
              this.postSpeak(200, "لا يوجد مربع تحرير. ")
            end
            return

           elseif text:lower() == "جديد" then
            this.postSpeak(200,"محوُ النص. ")
            task(1600, function()
              service.execute("清空")
              task(100, function()
                startVoiceRecognition(activity)
              end)
            end)
            return
           elseif text:lower() == "مراجعه النص" then
            gt= service.getText(node)
            this.postSpeak(200,gt)
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
               else
                handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
            return

           elseif text:lower() == "الاوامر" then
            this.postSpeak(200, "الأوامرُ الرئيسية")
            task(1000, function()
              general()
            end)
            return
           elseif text:lower() == "توقف قليلا" then
            this.postSpeak(200,"إرتح قليلاً، ثم إستأنِفِ الإملاءَ بعدَ سماع النغمة. ")

            handler.postDelayed(function()
              startVoiceRecognition(activity)
            end, 15000)
            return
           else
            this.postSpeak(200, "لا يوجد أمرٌ صوتيٌّ متطابق. ")

            return
          end

          service.paste(text .. ". \n")

          this.postSpeak(200, text)

          local function checkSpeakingStatus()
            if not service.isSpeaking() then
              startVoiceRecognition(activity)
             else
              handler.postDelayed(checkSpeakingStatus, 1000)
            end
          end

          handler.postDelayed(checkSpeakingStatus, 1500)

         else
          startVoiceRecognition(activity)
        end
      end,
      onError = function(error)
        this.postSpeak(200,"لم يتم التقاط أي نص.")

      end
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
  end

  startVoiceRecognition(activity)
end

general()